%global goipath         go.pantheon.tech/stonework
%global forgeurl        https://github.com/PANTHEONtech/StoneWork

Version:        23.06.1

%gometa

%global common_description %{expand:
A high-performance data plane, modular control plane solution.
StoneWork is used by PANTHEON.tech to integrate its cloud-native
network functions on top of a single shared FD.io VPP data plane
instance, to achieve the best possible resource utilization.}

%global golicenses      LICENSE
%global godocs          README.md

Name:           %{goname}
Release:        1%{?dist}
Summary:        A high-performance data plane, modular control plane solution

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

BuildRequires:  golang(github.com/apparentlymart/go-cidr/cidr)
BuildRequires:  golang(github.com/bufbuild/protocompile)
BuildRequires:  golang(github.com/buildkite/interpolate)
BuildRequires:  golang(github.com/compose-spec/compose-go/cli)
BuildRequires:  golang(github.com/docker/cli/cli/streams)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/fsnotify/fsnotify)
BuildRequires:  golang(github.com/ghodss/yaml)
BuildRequires:  golang(github.com/go-errors/errors)
BuildRequires:  golang(github.com/goccy/go-yaml)
BuildRequires:  golang(github.com/gookit/color)
BuildRequires:  golang(github.com/manifoldco/promptui)
BuildRequires:  golang(github.com/moby/term)
BuildRequires:  golang(github.com/namsral/flag)
BuildRequires:  golang(github.com/olekukonko/tablewriter)
BuildRequires:  golang(github.com/onsi/gomega)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/unrolled/render)
BuildRequires:  golang(github.com/vishvananda/netlink)
BuildRequires:  golang(github.com/vishvananda/netns)
BuildRequires:  golang(go.fd.io/govpp)
BuildRequires:  golang(go.ligato.io/cn-infra/v2)
BuildRequires:  golang(go.ligato.io/vpp-agent/v3)
BuildRequires:  golang(golang.org/x/exp/slices)
BuildRequires:  golang(google.golang.org/grpc)
BuildRequires:  golang(google.golang.org/protobuf/proto)
BuildRequires:  golang(gopkg.in/yaml.v3)

%description
%{common_description}

%godevelpkg

%package -n stonework
Summary:       %{summary}

%description -n stonework
%{common_description}

This package contains binaries stonework, stonework-init, mockcnf, proto-rootgen

%prep
%goprep

%build
for cmd in cmd/mockcnf cmd/stonework cmd/stonework-init cmd/proto-rootgen; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%godevelinstall
install -m 0755 -vd %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}

%gopkgfiles

%files -n stonework
%license %{golicenses}
%doc docs examples experiments
%{_bindir}/*

%changelog
